<?php
require_once '../system/sys.php';

$config['previewsize'] = '50';
$dir = isset($_GET['dir']) ? check($_GET['dir']) : '';
$name = isset($_GET['name']) ? check($_GET['name']) : '';

if (preg_match('|^[a-z0-9_\-/]+$|i', $dir) && preg_match('|^[a-z0-9_\.\-]+$|i', $name)) {
    if (file_exists(FLEVEL . $dir . '/' . $name)) {
        $getim = getimagesize(FLEVEL . $dir . '/' . $name);

        if ($getim[2] == 1 || $getim[2] == 2 || $getim[2] == 3) {
            $width = $getim[0];
            $height = $getim[1];

            if ($width > $config['previewsize'] || $height > $config['previewsize']) {
                $x_ratio = $config['previewsize'] / $width;
                $y_ratio = $config['previewsize'] / $height;

                if (($x_ratio * $height) < $config['previewsize']) {
                    $tn_height = ceil($x_ratio * $height);
                    $tn_width = $config['previewsize'];
                } else {
                    $tn_width = ceil($y_ratio * $width);
                    $tn_height = $config['previewsize'];
                } 
                // -------------------------------//
                if ($getim[2] == 2) {
                    $img = imagecreatefromjpeg(FLEVEL . $dir . '/' . $name);
                    $dst = imagecreatetruecolor($tn_width, $tn_height);
                    imagecopyresampled($dst, $img, 0, 0, 0, 0, $tn_width, $tn_height, $width, $height);

                    header('content-type: image/jpeg');
                    header('Content-Disposition: filename="' . $name . '"');
                    imagejpeg ($dst, null, 75);
                    imagedestroy($img);
                    imagedestroy($dst);
                } 
                // -------------------------------//
                if ($getim[2] == 1) {
                    $img = imagecreatefromgif(FLEVEL . $dir . '/' . $name);
                    $dst = imagecreatetruecolor($tn_width, $tn_height);

                    $colorTransparent = imagecolortransparent($img);
                    imagepalettecopy($img, $dst);
                    imagefill($dst, 0, 0, $colorTransparent);
                    imagecolortransparent($dst, $colorTransparent);
                    imagetruecolortopalette($dst, true, 256);

                    imagecopyresampled($dst, $img, 0, 0, 0, 0, $tn_width, $tn_height, $width, $height);

                    header('content-type: image/gif');
                    header('Content-Disposition: filename="' . $name . '"');
                    imagegif ($dst);
                    imagedestroy($img);
                    imagedestroy($dst);
                } 
                // -------------------------------//
                if ($getim[2] == 3) {
                    $img = imagecreatefrompng(FLEVEL . $dir . '/' . $name);
                    $dst = imagecreatetruecolor($tn_width, $tn_height);

                    $colorTransparent = imagecolortransparent($img);
                    imagepalettecopy($img, $dst);
                    imagefill($dst, 0, 0, $colorTransparent);
                    imagecolortransparent($dst, $colorTransparent);
                    imagetruecolortopalette($dst, true, 256);

                    imagecopyresampled($dst, $img, 0, 0, 0, 0, $tn_width, $tn_height, $width, $height);

                    header('content-type: image/png');
                    header('Content-Disposition: filename="' . $name . '"');
                    imagepng ($dst);
                    imagedestroy($img);
                    imagedestroy($dst);
                } 
            } else {
                $filename = file_get_contents(FLEVEL . $dir . '/' . $name);
                header('Content-type: ' . $getim['mime']);
                header('Content-Disposition: filename="' . $name . '"');
                header('Content-Length: ' . strlen($filename));
                echo $filename;
            } 
        }
    }
} 
exit;

?>